//------------------------------------------------------------------------------
//
//  npplot.c
//  npe
//
//  Created by Shane Saxon on 2/19/10.
//  Copyright Saxon Digital 2010. All rights reserved.
//
//------------------------------------------------------------------------------

#include <stdlib.h>

#include "npplot.h"


//------------------------------------------------------------------------------
void npInitAllPlots (void* dataRef)
{
	int i = 0;

	pData data = (pData) dataRef;

	for (i=0; i < kPlotMaximum; i++)
		data->io.plot[i] = NULL;
}

//------------------------------------------------------------------------------
void npInitPlot (pRecPlot plot)
{
	plot->vertexCount = 3000;								//debug, tarzan
	plot->arrayIndex = 0;
	plot->vertexArray = NULL;
	plot->colorArray = NULL;
	
	plot->sampleInterval = 1;			//use 1 to not skip any samples
	plot->averageType = kAverage;

	plot->channel.x = kChannelOscilloscope;
	plot->channel.y = kChannelCycleCount;
	plot->channel.z = kChannelNull;

	plot->color.r = 255;					//yellow, fully opaque
	plot->color.g = 127;
	plot->color.b = 127;
	plot->color.a = 255;
	plot->colorIndex = 0;
	plot->colorFade = FALSE;
	plot->altColorUpdate = FALSE;
	
	plot->screenPosition.x = 0.0;		//center the plot in the middle of screen
	plot->screenPosition.y = 0.0 - (kGridCount / 2);
	plot->screenPosition.z = 0.0;
	
	plot->translate.x = 0.0;				//no translate
	plot->translate.y = 0.0;
	plot->translate.z = 0.0;
	
	plot->translateRate.x = 0.0;			//no change in translate
	plot->translateRate.y = 0.0;
	plot->translateRate.z = 0.0;
	
	plot->scale.x = 1.0; //kDefaultScale;			//scaler multiple of 1.0 is no scaling,	zz debug
	plot->scale.y = 1.0;
	plot->scale.z = 1.0;			// 1.0

	plot->scaleRate.x = 0.0;				//scaler multiple of 1.0 is no scaling
	plot->scaleRate.y = 0.0;
	plot->scaleRate.z = 0.0;

	plot->rotate.angle = 0.0;				//no rotation
	plot->rotate.x = 0.0;
	plot->rotate.y = 0.0;
	plot->rotate.z = 1.0;					//vector pointing in Z with 0 rotation

	plot->rotateRate.angle = 0.0;			//no change in rotation
	plot->rotateRate.x = 0.0;
	plot->rotateRate.y = 0.0;
	plot->rotateRate.z = 0.0;

	plot->center = FALSE;
	plot->centerPerGridSpace = FALSE;
	plot->scroll = FALSE;
	plot->hide = FALSE;						//hide the plot
	plot->freeze = FALSE;					//freeze current state of plot
	plot->triggerOn = FALSE;
	plot->triggerOneShot = FALSE;
	plot->triggerLevel = 0.0;
	
	plot->autoZoom.x = FALSE;
	plot->autoZoom.y = FALSE;
	plot->autoZoom.z = FALSE;
	
	plot->lineWidth = 0.0;
	plot->pointSize = 1.0;					//1.0 is one pixel on the screen
	plot->circle = 0.0;						//1/4 grid unit radius
	
	plot->drawSurface = FALSE;
	
	plot->drawVideo = FALSE;
	plot->bias = 0.0;
	plot->gain = 1.0;
	
	plot->drawCurrentValue.x = FALSE;
	plot->drawCurrentValue.y = FALSE;
	plot->drawCurrentValue.z = FALSE;
	
	plot->drawTranslate.x = FALSE;
	plot->drawTranslate.y = TRUE;
	plot->drawTranslate.z = FALSE;
	
	plot->drawScale.x = FALSE;
	plot->drawScale.y = TRUE;
	plot->drawScale.z = FALSE;	
	
	plot->drawRotate.x = FALSE;
	plot->drawRotate.y = TRUE;
	plot->drawRotate.z = FALSE;
	
	plot->drawPullLimits = FALSE;
}

//------------------------------------------------------------------------------
void npClosePlot(void* dataRef)
{
	
}

//------------------------------------------------------------------------------
void npCloseAllPlots(void* dataRef)
{
	
}

