//------------------------------------------------------------------------------
//
//  npplot.h
//  npe
//
//  Created by Shane Saxon on 2/19/10.
//  Copyright Saxon Digital 2010. All rights reserved.
//
//------------------------------------------------------------------------------

#ifndef npplot_H_
#define npplot_H_

#include <freeglut.h>
#include "../npdata.h"

void npInitPlot (void* dataRef);
void npInitAllPlots (void* dataRef);

void npClosePlot (void* dataRef);
void npCloseAllPlots(void* dataRef);


struct recPlot
{
	void*		pWnd;						//videogl data

	int			vertexCount;
	int			arrayIndex;
	GLfloat		*vertexArray;
	GLubyte		*colorArray;
	GLubyteRGBA	color;						//the current color to assign to new data
	int			colorIndex;
	GLboolean	colorFade;
	GLboolean	altColorUpdate;
	int			previousRecentIndex;

	IntXYZ		channel;					//data number to use for x,y,z and scale
	
	int			sampleInterval;				//number of cycles per sample
	int			averageType;
	
	GLfloatXYZ	screenPosition;				//screen position of the plot center

	GLfloatAngleXYZ rotate;					//possible use of angling the scale axes
	GLfloatXYZ	scale;						//amount to scale plot by
	GLfloatXYZ	translate;					//pans the location of the plot

	GLfloatAngleXYZ rotateRate;				//possible use of angling the scale axes
	GLfloatXYZ	scaleRate;					//amount to scale plot by
	GLfloatXYZ	translateRate;				//pans the location of the plot, pronunciar en Espanol, lol
	
	GLboolean	hide;						//hides the plot, but still collects data
	GLboolean	freeze;						//freezes current state of plot 
	GLboolean	center;						//center with current value at origin
	GLboolean	centerPerGridSpace;			//when center is on use gridSpace increments
	GLboolean	scroll;						//scroll with current value on right edge
	GLboolean	triggerOn;
	GLboolean	triggerOneShot;
	GLfloat		triggerLevel;
	BoolXYZ		autoZoom;
	
	GLboolean	drawSurface;
	GLboolean	drawPolygons;
	GLfloat		lineWidth;
	GLfloat		pointSize;
	GLfloat		circle;

	GLboolean	drawVideo;
	GLfloat		bias;
	GLfloat		gain;
	
	BoolXYZ		drawCurrentValue;		//draw the current values
	BoolXYZ		drawTranslate;			//draw the translate
	BoolXYZ		drawScale;				//draw the scales for the axes
	BoolAXYZ	drawRotate;
	GLboolean	drawPullLimits;
};
typedef struct recPlot recPlot;
typedef struct recPlot *pRecPlot;


#endif

