//------------------------------------------------------------------------------
//
//  npctrl.h
//  npe
//
//  Created by Shane Saxon on 2/19/10.
//  Copyright Saxon Digital 2010. All rights reserved.
//
//------------------------------------------------------------------------------

#ifndef npctrl_H_
#define npctrl_H_


// 120Hz timer, 60, 30, 24
// 119.88Hz timer, 59.94, 29.97, 23.976


//---- Graph Command Constants ----

enum {
	//global graph commands
	kGraphMenu = 4242,		//
	kGraphDrawIndicators,
	
	kGraphNew,
	kGraphDelete,

	kGraphNext,
	kGraphGrid,
	
	//translate, rotate and scale selected objects
	kGraphSelectAxes,
	
	kGraphXincrease,
	kGraphXincreaseOff,
	kGraphXdecrease,
	kGraphXdecreaseOff,
	
	kGraphYincrease,
	kGraphYincreaseOff,
	kGraphYdecrease,
	kGraphYdecreaseOff,
	
	kGraphZincrease,
	kGraphZincreaseOff,
	kGraphZdecrease,
	kGraphZdecreaseOff,
	
	kGraphRotateIncreaseOn,
	kGraphRotateIncreaseOff,
	kGraphRotateDecreaseOn,
	kGraphRotateDecreaseOff,
	
	kGraphZoomOn,
	kGraphZoomOff,
	
	kGraphClearFrameBuffer, 
	
	//plot specific graph commands
	kGraphSampleInterval,
	kGraphChannelDown,
	kGraphChannelUp,
	kGraphColorDown,
	kGraphColorFade,
	kGraphAltColor,
	kGraphColorUp,
	kGraphColorPallete,
	
	kGraphFreeze,
	kGraphHide,
	kGraphClear,
	
	kGraphCenter,
	kGraphScroll,

	kGraphPoints,	
	kGraphLines,
	kGraphDrawPullLimits,
	kGraphSurface,
	kGraphPolygons,
	kGraphAlphaUp,
	kGraphAlphaDown,
	kGraphBiasUp,
	kGraphBiasDown,
	kGraphGainUp,
	kGraphGainDown,

	kEventLowSetpoint,
	kEventHighSetpoint,

	kFullScreenExit
};


//--- Functions ----------------------------------------------------------------

void npInitCtrl (void* dataRef);
void npCloseCtrl (void* dataRef);

int npMainAppLoop(void* dataRef);

void npCtrlCommand (int command, void* dataRef);

void npCtrlUpdateData (void* dataRef);
void npCtrlUpdateEngine (void* dataRef);

#endif